package org.stm.spider.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.stm.spider.entity.WbTmpData;
import org.stm.spider.service.IWbTmpDataService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

 /**
 * @Description: 抓取记录
 * @Author: jeecg-boot
 * @Date:   2023-05-08
 * @Version: V1.0
 */
@Api(tags="抓取记录")
@RestController
@RequestMapping("/spider/wbTmpData")
@Slf4j
public class WbTmpDataController extends JeecgController<WbTmpData, IWbTmpDataService> {
	@Autowired
	private IWbTmpDataService wbTmpDataService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbTmpData
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "抓取记录-分页列表查询")
	@ApiOperation(value="抓取记录-分页列表查询", notes="抓取记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<WbTmpData>> queryPageList(WbTmpData wbTmpData,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbTmpData> queryWrapper = QueryGenerator.initQueryWrapper(wbTmpData, req.getParameterMap());
		Page<WbTmpData> page = new Page<WbTmpData>(pageNo, pageSize);
		IPage<WbTmpData> pageList = wbTmpDataService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @GetMapping(value = "/allList")
	 public Result<List<WbTmpData>> queryAllList(WbTmpData wbTmpData,
					HttpServletRequest req) {
		 QueryWrapper<WbTmpData> queryWrapper = QueryGenerator.initQueryWrapper(wbTmpData, req.getParameterMap());
		 List<WbTmpData> list = wbTmpDataService.list(queryWrapper);
		 return Result.OK(list);
	 }
	
	/**
	 *   添加
	 *
	 * @param wbTmpData
	 * @return
	 */
	@AutoLog(value = "抓取记录-添加")
	@ApiOperation(value="抓取记录-添加", notes="抓取记录-添加")
	@RequiresPermissions("spider:wb_tmp_data:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbTmpData wbTmpData) {
		wbTmpDataService.save(wbTmpData);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbTmpData
	 * @return
	 */
	@AutoLog(value = "抓取记录-编辑")
	@ApiOperation(value="抓取记录-编辑", notes="抓取记录-编辑")
	@RequiresPermissions("spider:wb_tmp_data:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbTmpData wbTmpData) {
		wbTmpDataService.updateById(wbTmpData);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "抓取记录-通过id删除")
	@ApiOperation(value="抓取记录-通过id删除", notes="抓取记录-通过id删除")
	@RequiresPermissions("spider:wb_tmp_data:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbTmpDataService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "抓取记录-批量删除")
	@ApiOperation(value="抓取记录-批量删除", notes="抓取记录-批量删除")
	@RequiresPermissions("spider:wb_tmp_data:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbTmpDataService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "抓取记录-通过id查询")
	@ApiOperation(value="抓取记录-通过id查询", notes="抓取记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<WbTmpData> queryById(@RequestParam(name="id",required=true) String id) {
		WbTmpData wbTmpData = wbTmpDataService.getById(id);
		if(wbTmpData==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbTmpData);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbTmpData
    */
    @RequiresPermissions("spider:wb_tmp_data:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbTmpData wbTmpData) {
        return super.exportXls(request, wbTmpData, WbTmpData.class, "抓取记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("spider:wb_tmp_data:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbTmpData.class);
    }

	 @DeleteMapping(value = "/deleteRepetition")
	 public Result<?> deleteRepetition(HttpServletRequest request, HttpServletResponse response) {
		List<WbTmpData> list = wbTmpDataService.list();
		List<Integer> existIdList = new ArrayList<Integer>();
		 List<Integer> docIdList = new ArrayList<Integer>();

		 for(int i=0;i<list.size();i++){
			WbTmpData wbTmpData = list.get(i);
			Integer docId = wbTmpData.getComplianeNo();
			Integer id = wbTmpData.getId();
			if(docIdList.contains(docId)){
				existIdList.add(id);
			} else {
				docIdList.add(docId);
			}
		}

		for(int i=0;i<existIdList.size();i++){
			wbTmpDataService.removeById(existIdList.get(i));
		}

		return Result.OK("完成!");
	 }

}
